#pragma once
#include <iostream>
#include <fstream>
#include <algorithm>
#include <iterator>
#include <vector>
#include <deque>
#include <list>
#include <string>
#include <sstream>

void createData_stream() {
	std::srand(std::time(nullptr));
	std::ofstream ofstr;
	ofstr.open("Data.txt");
	for (int i = 0; i < 99; ++i) ofstr << -50 + rand() % 101 << "\t";
	ofstr << -50 + rand() % 101 << std::endl;
	ofstr.close();
}

void createData_generate() {
	std::vector<int> vec(99);
	std::generate(vec.begin(), vec.end(), []() {return -50 + rand() % 101; });
	std::ofstream ofstr;
	ofstr.open("Data.txt");
	std::copy(vec.begin(), vec.end(), std::ostream_iterator<int>(ofstr, "\t"));
	ofstr << *(vec.end() - 1) << std::endl;
	ofstr.close();
}

template<typename _Container>
void loadData_stream(_Container& container, const std::string& name_file) {
	std::ifstream ifstr(name_file, std::ios::out);
	if (!ifstr) {
		std::cerr << "Cannot open file " << name_file << std::endl;
		exit(EXIT_FAILURE);
	}
	std::string line;
	while (std::getline(ifstr, line, '\t')) {
		std::istringstream iss(line);
		typename _Container::value_type elem;
		if (!(iss >> elem)) break;
		container.push_back(elem);
	}
	ifstr.close();
	std::cout << "loadData_stream : " << std::endl;
	for (const auto& e : container) std::cout << e << "  ";
}

template<typename _Container>
void loadData_copy(_Container& t_container, const std::string& name_file) {
	std::ifstream ifstr(name_file, std::ios::out);
	if (!ifstr) {
		std::cerr << "Cannot open file " << name_file << std::endl;
		exit(EXIT_FAILURE);
	}
	else {
		std::istream_iterator<typename _Container::value_type> iterBegin(ifstr);
		std::istream_iterator<typename _Container::value_type> iterEnd;
		std::copy(iterBegin, iterEnd, t_container.begin());
		std::cout << std::endl << "loadData_copy : \n";
		for (const auto& e : t_container) std::cout << e << "  ";
	}
	ifstr.close();
}


//Modify change each even numbers into max
template<typename _Container>
_Container modify_1(const _Container& container)
{
	auto max_num = *std::max_element(container.begin(), container.end());

	auto sum_all = 0;
	_Container new_con;
	for (const auto& ele : container) {
		sum_all += ele;
		if (ele > 0) new_con.push_back(max_num);
		else new_con.push_back(ele);
	}
	new_con.push_back(sum_all);
	new_con.push_back(abs(sum_all) / std::size(container));
	return new_con;
}

template<typename Input_Iterator, typename Dest_Iterator>
void modify_iterator(const Input_Iterator iter_beg, const Input_Iterator iter_end, Dest_Iterator dest_iter) {
	auto tmp_iter = dest_iter;

	auto max_num = *std::max_element(iter_beg, iter_end);
	for (auto it = iter_beg; it != iter_end; ++it) {
		if ((*it) > 0) *(tmp_iter++) = max_num;
		else *(tmp_iter++) = (*it);
	}
}

template<typename _Container>
void modify_for_each(_Container& container) {
	auto max_num = *std::max_element(container.begin(), container.end());
	auto modify = [&](typename _Container::value_type& ele) {
		if (ele > 0) ele = max_num;
        // НЕ НАДО НИЧЕГО ВОЗВРАЩАТЬ, ПРОСТО НЕ ИЗМЕНЯЕМ ЭТОТ ЭЛЕМЕНТ И ВСЁ
        // ВОЗВРАЩАЕМОЕ ЗНАЧЕНИЕ ПРЕДИКАТА В АЛГОРИТМЕ for_each НЕ ИСПОЛЬЗУЕТСЯ
	};
	std::for_each(container.begin(), container.end(), modify);
}


void modify_transform(const std::string& input_name_file, const std::string& output_name_file) {
	std::ifstream ifstr(input_name_file);
	std::ofstream ofstr(output_name_file, std::ios::app);
	if (!ifstr) std::cerr << "Cannot open file " << input_name_file << std::endl;
	else {
        // НАДО ИСПОЛЬЗОВАТЬ ИТЕРАТОР std::back_inserter, ПОТОМУ ЧТО МЫ НЕ ЗНАЕМ
        // СКОЛЬКО ЭЛЕМЕНТОВ НАДО БУДЕТ ВСТАВИТЬ
		std::vector <int> vec(200);
		std::copy(std::istream_iterator<int>(ifstr), std::istream_iterator<int>(), std::back_inserter(vec));

		auto max_num = *std::max_element(vec.begin(), vec.end());
		std::cout << "max_num = " << max_num << std::endl;
		auto modify = [&](auto& ele) {
			if (ele > 0) ele = max_num;
			return ele;
		};
		std::transform(vec.begin(), vec.end(), std::ostream_iterator<int>(ofstr, "\t"), modify);
		ofstr << std::endl;
	}
}



template <typename _Container>
void outputResult_stream(const std::string& name_file, const _Container& t_container) {
	std::ofstream ostr(name_file, std::ios::app);
	if (!ostr) {
		std::cerr << "Cannot open file " << name_file << std::endl;
		exit(EXIT_FAILURE);
	}
	for (const auto& e : t_container) ostr << e << "\t";
	ostr << std::endl;
	ostr.close();
}

template <typename _Container>
void outputResult_copy(const std::string& name_file, const _Container& t_container) {
	std::ofstream ostr(name_file, std::ios::app);
	std::copy(t_container.begin(), t_container.end(), std::ostream_iterator<typename _Container::value_type>(ostr, "\t"));
	ostr << std::endl;
	ostr.close();
}





