#pragma once
#include <string>
#include <initializer_list>
#include <map>
#include <any>
#include <vector>
#include <exception>
#include <cmath>

struct work {
	char company[50];
	char work_type[50];
	char work_unit[50];
	double salary_work_unit;
	int day_end;
	double percentage_completed;
	work() = default;
	work(const char*, const char* ,const char*, double, int, double);
	friend std::istream& operator >> (std::istream& is, work& t_work);
	friend std::ostream& operator << (std::ostream& os, const work& t_work);
};


class Record {
private:
	std::string name_record;
	std::map<int,work> record_map;
	void get_data();
public:
	Record() = default;
	~Record() = default;
	Record(const std::string&);
	void create_record();
	void add_to_record(const work&);
	void add_to_record_list(const std::initializer_list<work>&);
	void delete_from_record(int);
	void replace_in_record(int, const work&);
	void transform_into_text();

	void search_by_company(const std::string&);
	void search_by_work_type(const std::string&);
	void search_by_day_end(int);
};


